//------------------------------------------------------------------------------
// Copyright (C) 2010, Raditex AB
// All rights reserved.
//
// FreeSCADA 
// http://www.FreeSCADA.com
// freescada@freescada.com
//
//------------------------------------------------------------------------------

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <syslog.h>
#include <string.h>

#include <stdio.h>
#include <mbus.h>

//
// test CHECKSUM and LENGTH calculation
//

//------------------------------------------------------------------------------
// Execution starts here:
//
//------------------------------------------------------------------------------
int
main(int argc, char **argv)
{
    int ret;
    mbus_frame *frame;
    
    frame = mbus_frame_new(MBUS_FRAME_TYPE_LONG);
    
    //
    // Master to Slave: 68 04 04 68 | 53 FE 50 | 10 | B1 16
    // Slave to Master: E5
    //
    
//    frame.start1  = 0x68;  // MBUS_FRAME_LONG_START
//    frame.length1 = 0x00;  //calc
//    frame.length2 = 0x00;  //calc
//    frame.start2  = 0x68;  // MBUS_FRAME_LONG_START

    frame->control = MBUS_CONTROL_MASK_SND_UD | MBUS_CONTROL_MASK_DIR_M2S | MBUS_CONTROL_MASK_FCV;
    frame->address = MBUS_ADDRESS_BROADCAST_REPLY;
    frame->control_information = MBUS_CONTROL_INFO_APPLICATION_RESET;

//    frame.checksum = 0x00; //calc 
//    frame.stop     = 0x16; // MBUS_FRAME_STOP

    frame->data_size = 1;
    frame->data[0]   = 0x10;

    if ((ret = mbus_frame_print(frame)) < 0)
    {
        printf("%s: mbus_frame_print -> %d\n", __PRETTY_FUNCTION__, ret);
        return -1;
    }
    
    if ((ret = mbus_frame_calc_length(frame)) < 0)
    {
        printf("%s: mbus_frame_calc_length -> %d\n", __PRETTY_FUNCTION__, ret);
        return -1;
    }

    if ((ret = mbus_frame_print(frame)) < 0)
    {
        printf("%s: mbus_frame_print -> %d\n", __PRETTY_FUNCTION__, ret);
        return -1;
    }
    
    if ((ret = mbus_frame_calc_checksum(frame)) < 0)
    {
        printf("%s: mbus_frame_checksum -> %d\n", __PRETTY_FUNCTION__, ret);
        return -1;
    }

    if ((ret = mbus_frame_print(frame)) < 0)
    {
        printf("%s: mbus_frame_print -> %d\n", __PRETTY_FUNCTION__, ret);
        return -1;
    }
    
    return 0;
}



