//------------------------------------------------------------------------------
// Copyright (C) 2010, Raditex AB
// All rights reserved.
//
// FreeSCADA 
// http://www.FreeSCADA.com
// freescada@freescada.com
//
//------------------------------------------------------------------------------

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <syslog.h>
#include <string.h>
#include <glib.h>

#include <stdio.h>
#include <mbus.h>

int
convert_hex_to_int(char lsb, char msb)
{   
    char buff[3];
    int val;
    
    buff[0] = msb;
    buff[1] = lsb;
    buff[2] = 0;
    
    val = strtol(buff, NULL, 16);

    return val;
}

int
main(int argc, char **argv)
{
    int i = 0, j = 0;
    gchar buff[1024], buff_bin[1024];

    bzero((void *)buff, sizeof(buff));
    bzero((void *)buff_bin, sizeof(buff_bin));

    mbus_frame *frame;
    mbus_frame_data frame_data;

    snprintf(buff, sizeof(buff),
            "683D3D6808017288638009824D02044100000004079564"
            "04000C15797549000B2D4744000B3B9586000A5A11080A"
            "5E61030B61964400026C52140227A1010F0000C61610");
   
    while (i <= strlen(buff))
    {
        buff_bin[j++] = convert_hex_to_int(buff[i++], buff[i++]);
    }

    frame = mbus_frame_new(MBUS_FRAME_TYPE_ANY);
    i = mbus_parse(frame, buff_bin, j);
    //printf("M-Bus layer requested %d more bytes\n", i);
    
    mbus_frame_data_parse(frame, &frame_data);
    //mbus_frame_print(frame);        
    //mbus_frame_data_print(&frame_data);
    mbus_frame_data_print_xml(&frame_data);
    
    mbus_frame_free(frame);

    return -1;
}

