//------------------------------------------------------------------------------
// Copyright (C) 2010, Raditex AB
// All rights reserved.
//
// FreeSCADA 
// http://www.FreeSCADA.com
// freescada@freescada.com
//
//------------------------------------------------------------------------------
#ifndef FS_NET_H
#define FS_NET_H

#include <unistd.h>
#include <fcntl.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/uio.h>

#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>

#include <glib.h>

typedef GIOChannel* (*FsNetConnectCallback)(int, GIOChannel *, struct sockaddr_in *);

//GIOChannel *    fs_net_async_setup(int port, FsNetConnectCallback connect_cb, char *listen_addr);
//gboolean 	    fs_net_async_accept(GIOChannel *gio, GIOCondition condition, void *connect_cb);

//GIOChannel *    fs_net_create_gio(int sock, void *io_cb, gpointer cb_data);

//int 		fs_net_socket_accept(int sock);
int 		fs_net_socket_close(int sock);

GIOChannel *    fs_net_connection_setup(char *hostname, int port, void *io_cb, gpointer cb_data);
gint		fs_net_disconnect(GIOChannel *gio);

gint 		fs_net_send(GIOChannel *gio, gchar *buff, gint buff_len);
gint 		fs_net_read(GIOChannel *gio, gchar *buff, gint buff_max_len);

#define FS_NET_BUFFER_SIZE 8192
typedef struct _fs_net_buffer {
    GIOChannel *gio;
	gint offset;
	gint tag_idx;
	gchar buff[FS_NET_BUFFER_SIZE];
} FsNetBuffer;

gint            fs_net_read_nonblocking(GIOChannel *gio, FsNetBuffer *data);
gint            fs_net_read_data_nonblocking(GIOChannel *gio, FsNetBuffer *data, gint data_length);
gint            fs_net_buffer_new (GIOChannel *gio);
void            fs_net_buffer_free(GIOChannel *gio);
FsNetBuffer   * fs_net_buffer_get (GIOChannel *gio);


#endif /* FS_NET_H */



